## lomiri-telephony-service 0.6.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(lomiri-telephony-service VERSION 0.6.0 LANGUAGES CXX)
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)

# Standard install paths
include(GNUInstallDirs)

# Check for include files
include(CheckIncludeFileCXX)
include(CheckIncludeFile)

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

# just to make debug easier, print the system processor
message(STATUS "System processor: ${CMAKE_SYSTEM_PROCESSOR}")

set(TELEPHONY_SERVICE_DIR ${CMAKE_INSTALL_FULL_DATADIR}/lomiri-telephony-service)

configure_file(config.h.in ${CMAKE_CURRENT_BINARY_DIR}/config.h @ONLY)

# uninstall target
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
               "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
               IMMEDIATE @ONLY)
add_custom_target(uninstall "${CMAKE_COMMAND}"
                  -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

find_package(Qt5Contacts)
find_package(Qt5DBus)
find_package(Qt5Multimedia)
find_package(Qt5Qml)
find_package(Qt5Quick)
find_package(Qt5Test)
find_package(Qt5Feedback)
find_package(Qt5Network)
find_package(LibPhoneNumber REQUIRED)

include(qt5)

option(SKIP_QML_TESTS "Skip QML tests" OFF)
option(WANT_UI_SERVICES "Enable build of UI services" ON)

if(NOT CMAKE_CROSSCOMPILING)
    find_program(QMAKE_EXECUTABLE qmake)
    if(QMAKE_EXECUTABLE STREQUAL "QMAKE_EXECUTABLE-NOTFOUND")
        message(FATAL_ERROR "qmake not found")
    endif()
    execute_process(
        COMMAND ${QMAKE_EXECUTABLE} -query QT_INSTALL_QML
        RESULT_VARIABLE RESULT
        OUTPUT_VARIABLE QT_INSTALL_QML
        OUTPUT_STRIP_TRAILING_WHITESPACE
    )
    if(NOT RESULT EQUAL 0)
        message(FATAL_ERROR "Failed to determine QT_INSTALL_QML from qmake")
    endif()
else()
    # qmake isn't multi-arch aware as it installs arch-specific mkspec files
    # in to /usr/share, so we can't use it here (we'd need a qmake binary
    # for the host arch using data for the target arch)
    set(QT_INSTALL_QML "/usr/lib/${CMAKE_LIBRARY_ARCHITECTURE}/qt5/qml")
endif()

find_package(PkgConfig REQUIRED)
pkg_check_modules(TP_QT5 REQUIRED TelepathyQt5)
pkg_check_modules(TP_QT5_FS REQUIRED TelepathyQt5Farstream)
pkg_check_modules(NOTIFY REQUIRED libnotify)
pkg_check_modules(TPFS REQUIRED telepathy-farstream)
pkg_check_modules(GST REQUIRED gstreamer-1.0)
pkg_check_modules(FS REQUIRED farstream-0.2)
pkg_check_modules(PULSEAUDIO libpulse)
pkg_check_modules(HISTORY REQUIRED lomiri-history-service)

if (WANT_UI_SERVICES)
    pkg_check_modules(MESSAGING_MENU REQUIRED messaging-menu)
    pkg_check_modules(UserMetrics REQUIRED libusermetricsinput-1)
    pkg_check_modules(URL_DISPATCHER REQUIRED lomiri-url-dispatcher)

    add_definitions(-DWANT_UI_SERVICES)
    message("Building with UI services")
else()
    message("Bulding of UI services is disabled")
endif()

add_definitions(-DQT_NO_KEYWORDS)

include_directories(
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}
    )

# generate a macro to make it easier to enable coverage support on targets
function(ENABLE_COVERAGE)
    get_directory_property(COVERAGE_TARGETS DIRECTORY ${CMAKE_SOURCE_DIR} COVERAGE_TARGETS)
    list(APPEND COVERAGE_TARGETS ${ARGN})
    MESSAGE(STATUS "Enabling coverage report for target(s): ${ARGN}")
    set_property(DIRECTORY ${CMAKE_SOURCE_DIR} PROPERTY COVERAGE_TARGETS ${COVERAGE_TARGETS})
endfunction()

include(CTest)

set(CMAKE_CXX_STANDARD 17)

set(DATA_DIR "${CMAKE_SOURCE_DIR}/data")
# install assets
set(ASSETS_DIR assets)
install(DIRECTORY ${ASSETS_DIR} DESTINATION ${TELEPHONY_SERVICE_DIR})

add_subdirectory(liblomiritelephonyservice)
add_subdirectory(Lomiri)
add_subdirectory(handler)
add_subdirectory(tools)
add_subdirectory(icons)
add_subdirectory(po)
if (BUILD_TESTING)
    add_subdirectory(tests)
endif()
add_subdirectory(protocols)

if (WANT_UI_SERVICES)
    add_subdirectory(indicator)
    add_subdirectory(approver)
endif()

include(EnableCoverageReport)
#####################################################################
# Enable code coverage calculation with gcov/gcovr/lcov
# Usage:
#  * Switch build type to coverage (use ccmake or cmake-gui)
#  * Invoke make, make test, make coverage
#  * Find html report in subdir coveragereport
#  * Find xml report feasible for jenkins in coverage.xml
#####################################################################
IF(CMAKE_BUILD_TYPE MATCHES [cC][oO][vV][eE][rR][aA][gG][eE])
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ftest-coverage -fprofile-arcs" )
  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ftest-coverage -fprofile-arcs" )
  SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -coverage" )
  SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -coverage" )
  GET_DIRECTORY_PROPERTY(COVERAGE_TARGETS DIRECTORY ${CMAKE_SOURCE_DIR} COVERAGE_TARGETS)
  ENABLE_COVERAGE_REPORT(TARGETS ${COVERAGE_TARGETS})
ENDIF(CMAKE_BUILD_TYPE MATCHES [cC][oO][vV][eE][rR][aA][gG][eE])

=== tests/CMakeLists.txt ===
include (GenerateTest)

add_subdirectory(common)
add_subdirectory(handler)
add_subdirectory(liblomiritelephonyservice)
add_subdirectory(Lomiri.Telephony)

if (WANT_UI_SERVICES)
    add_subdirectory(approver)
    add_subdirectory(indicator)
endif()

=== tests/liblomiritelephonyservice/CMakeLists.txt ===
set(LIBLOMIRITELEPHONYSERVICE_DIR ${CMAKE_SOURCE_DIR}/liblomiritelephonyservice)
include_directories(
    ${CMAKE_CURRENT_BINARY_DIR}
    ${LIBLOMIRITELEPHONYSERVICE_DIR}
    ${TP_QT5_INCLUDE_DIRS}
    ${CMAKE_SOURCE_DIR}/tests/common
    ${CMAKE_BINARY_DIR}/tests/common
    ${GSETTINGS_QT_INCLUDE_DIRS}
    )

add_executable(GreeterContactsTestServerExe GreeterContactsTestServer.cpp)
target_link_libraries(GreeterContactsTestServerExe Qt5::Core Qt5::DBus)

add_executable(ToneGeneratorMock ToneGeneratorMock.cpp)
target_link_libraries(ToneGeneratorMock Qt5::Core Qt5::DBus)

add_executable(IndicatorMock IndicatorMock.cpp)
target_link_libraries(IndicatorMock Qt5::Core Qt5::DBus)

generate_test(GreeterContactsTest USE_DBUS
              SOURCES GreeterContactsTest.cpp ${LIBLOMIRITELEPHONYSERVICE_DIR}/greetercontacts.cpp
              LIBRARIES Qt5::Contacts Qt5::Core Qt5::DBus Qt5::Test
              ENVIRONMENT XDG_SESSION_CLASS=greeter XDG_GREETER_DATA_DIR=${CMAKE_BINARY_DIR}/Testing/Temporary
              TASKS --task ${CMAKE_CURRENT_BINARY_DIR}/GreeterContactsTestServerExe --task-name server --ignore-return
              WAIT_FOR org.freedesktop.Accounts)
set_target_properties(GreeterContactsTest PROPERTIES COMPILE_DEFINITIONS "AS_BUSNAME=sessionBus;CMAKE_SOURCE_DIR=\"${CMAKE_SOURCE_DIR}\"")
add_dependencies(GreeterContactsTest GreeterContactsTestServerExe)

generate_test(GreeterContactsThreadTest USE_DBUS
              SOURCES GreeterContactsThreadTest.cpp ${LIBLOMIRITELEPHONYSERVICE_DIR}/greetercontacts.cpp
              LIBRARIES Qt5::Contacts Qt5::Core Qt5::DBus Qt5::Test
              ENVIRONMENT XDG_SESSION_CLASS=greeter XDG_GREETER_DATA_DIR=${CMAKE_BINARY_DIR}/Testing/Temporary
              TASKS --task ${CMAKE_CURRENT_BINARY_DIR}/GreeterContactsTestServerExe --task-name server --ignore-return
              WAIT_FOR org.freedesktop.Accounts)
set_target_properties(GreeterContactsThreadTest PROPERTIES COMPILE_DEFINITIONS "AS_BUSNAME=sessionBus;CMAKE_SOURCE_DIR=\"${CMAKE_SOURCE_DIR}\"")
add_dependencies(GreeterContactsThreadTest GreeterContactsTestServerExe)

generate_test(ToneGeneratorTest USE_DBUS
              SOURCES ToneGeneratorTest.cpp ${LIBLOMIRITELEPHONYSERVICE_DIR}/tonegenerator.cpp
              LIBRARIES Qt5::Core Qt5::DBus Qt5::Test
              TASKS --task ${CMAKE_CURRENT_BINARY_DIR}/ToneGeneratorMock --task-name tone-gen --ignore-return
              WAIT_FOR com.Nokia.Telephony.Tones)
add_dependencies(ToneGeneratorTest ToneGeneratorMock)

generate_test(CallNotificationTest USE_DBUS
              SOURCES CallNotificationTest.cpp ${LIBLOMIRITELEPHONYSERVICE_DIR}/callnotification.cpp
              LIBRARIES Qt5::Core Qt5::DBus Qt5::Test
              TASKS --task ${CMAKE_CURRENT_BINARY_DIR}/IndicatorMock --task-name indicator --ignore-return
              WAIT_FOR com.lomiri.TelephonyServiceIndicator)

generate_test(ContactUtilsTest SOURCES ContactUtilsTest.cpp LIBRARIES Qt5::Contacts Qt5::Core Qt5::Test lomiritelephonyservice USE_UI)
generate_test(PhoneUtilsTest SOURCES PhoneUtilsTest.cpp LIBRARIES lomiritelephonyservice Qt5::Core Qt5::Test USE_UI)
generate_test(ProtocolTest
              SOURCES ProtocolTest.cpp ${LIBLOMIRITELEPHONYSERVICE_DIR}/protocol.cpp
              LIBRARIES Qt5::Core Qt5::Test Qt5::DBus
              ENVIRONMENT TELEPHONY_SERVICE_PROTOCOLS_DIR=${CMAKE_CURRENT_SOURCE_DIR}/testProtocols)
generate_test(ProtocolManagerTest
              SOURCES ProtocolManagerTest.cpp
              LIBRARIES Qt5::Core Qt5::Qml Qt5::Test Qt5::DBus Qt5::Contacts telepathy-qt5 lomiritelephonyservice
              ENVIRONMENT TELEPHONY_SERVICE_PROTOCOLS_DIR=${CMAKE_CURRENT_SOURCE_DIR}/testProtocols)


generate_telepathy_test(AccountEntryFactoryTest SOURCES AccountEntryFactoryTest.cpp)
generate_telepathy_test(AccountEntryTest SOURCES AccountEntryTest.cpp)
generate_telepathy_test(CallEntryTest SOURCES CallEntryTest.cpp)
generate_telepathy_test(ChatManagerTest SOURCES ChatManagerTest.cpp)
generate_telepathy_test(ChatEntryTest SOURCES ChatEntryTest.cpp)
generate_telepathy_test(OfonoAccountEntryTest SOURCES OfonoAccountEntryTest.cpp)
generate_telepathy_test(TelepathyHelperSetupTest SOURCES TelepathyHelperSetupTest.cpp)
# FIXME: investigate why this test is failing on arm64 / aarch64
if (NOT CMAKE_SYSTEM_PROCESSOR MATCHES "aarch64.*|AARCH64.*")
    generate_telepathy_test(TelepathyHelperTest SOURCES TelepathyHelperTest.cpp)
endif()
generate_telepathy_test(USSDManagerTest SOURCES USSDManagerTest.cpp)

=== debian/changelog ===
lomiri-telephony-service (0.6.0-1) unstable; urgency=medium

  * New upstream release.
  * debian/control:
    + Bump Standards-Version: to 4.7.0. No changes needed.
  * debian/patches:
    + Drop 1001_gettext-is-not-a-member-of-C.patch and 0001_indicator-
      authhandler.h-Correctly-include-Notificati.patch. Both applied
      upstream.
    + Drop 2001_use-new-lomiri-history-service.patch. Not required anymore.
    + Adjust patch 2002 to upstream's new Lomiri-namespacing improvements.
    + Add 1001_lomiri-ofono-setup.patch: Rename ofono-setup to lomiri-ofono-
      setup.
  * debian/copyright:
    + Update copyright attributions.
    + Update auto-generated copyright.in file.
  * debian/{*.install,not-installed}:
    + Add new polkit-1 .rules file, don't installed the .pkla file anymore
      (Closes: #1078325, #1093071).
    + Adjust to upstream's new Lomiri-namespacing improvements.
    + Adjust to renamed ofono-setup script.

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 15 Jan 2025 10:09:05 +0100

lomiri-telephony-service (0.5.3-3) unstable; urgency=medium

  * debian/patches:
    + Drop 1002_CMake-fix-dependency.patch. Not the right fix.
    + Add 2001_use-new-lomiri-history-service.patch.
    + Add 0001_indicator-authhandler.h-Correctly-include-Notificati.patch.
      Correctly include NotificationsInterface.h from
      ${CMAKE_BINARY_DIR}/indicator. (Closes: #1084166).
    + Add 2002_qtcontacts-sqlite.patch. Migrate to QtContact sqlite backend.
  * debian/control:
    + In B-D: field, switch from libhistoryservice-dev to
      liblomirihistoryservice-dev.
    + In B-D: field, switch from pkg-config to pkgconf.
    + Add D: (qml-module-lomiri-telephony): libqt5contact5-plugin-sqlite
      (and drop commented out qtcontact5-galera).

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 05 Oct 2024 22:13:00 +0200

lomiri-telephony-service (0.5.3-2) unstable; urgency=medium

  * debian/watch:
    + Update file for recent GitLab changes of the tags overview page.
  * debian/patches:
    + Add 1002_CMake-fix-dependency.patch. Fix unhandled dependency on
      generated .h file.
    + Add 1001_gettext-is-not-a-member-of-C.patch. Include libintl.h into
      :: namespace rather than into C::. Resolves conflict with abseil >=
      20230802.1. (Closes: #1068655).

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 16 Apr 2024 15:53:48 +0200

=== debian/control ===
Source: lomiri-telephony-service
Section: libs
Priority: optional
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
 Marius Gripsgard <marius@ubports.com>,
Build-Depends: cmake,
               dbus-test-runner,
               dconf-cli,
               debhelper-compat (= 13),
               gnome-keyring,
               liblomirihistoryservice-dev,
               libicu-dev,
               libmessaging-menu-dev,
               libnotify-dev,
               libphonenumber-dev,
               libtelepathy-qt5-dev,
               libprotobuf-dev,
               libpulse-dev,
               liblomiri-url-dispatcher-dev,
               pkgconf,
               python3,
               qml-module-qttest,
               qtbase5-dev (>= 5.0),
               qtdeclarative5-dev (>= 5.0),
               qtdeclarative5-dev-tools (>= 5.0),
               qtfeedback5-dev,
               qml-module-lomiri-components,
               qml-module-lomiri-layouts,
               qml-module-lomiri-performancemetrics,
               qml-module-lomiri-test,
               qtmultimedia5-dev (>= 5.0),
               qtpim5-dev (>= 5),
               libusermetricsinput-dev,
               telepathy-mission-control-5,
               xvfb <!nocheck>,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://gitlab.com/ubports/development/core/telephony-service/
Vcs-Browser: https://salsa.debian.org/ubports-team/lomiri-telephony-service/
Vcs-Git: https://salsa.debian.org/ubports-team/lomiri-telephony-service.git

Package: lomiri-telephony-service
Section: misc
Architecture: any
Multi-Arch: foreign
Conflicts: phone-app
Replaces: phone-app
Depends: lomiri-schemas,
         lomiri-history-service,
         libnotify4,
         telepathy-mission-control-5,
         lomiri-sounds,
         tone-generator,
         dconf-cli,
         python3,
         python3-dbus,
         python3-gi,
         ${misc:Depends},
         ${shlibs:Depends},
Suggests: telepathy-ofono
Description: Telephony service components for Lomiri - service daemon
 Telephony service components for Lomiri.
 .
 This package contains the backend components providing the telephony
 features such as calling and texting.

Package: qml-module-lomiri-telephony
Architecture: any
Multi-Arch: same
Depends: lomiri-schemas,
         libqt5contact5-plugin-sqlite,
         lomiri-telephony-service (>= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Suggests: telepathy-ofono
Description: Telephony service components for Lomiri - Telephony QML plugin
 Telephony service components for Lomiri.
 .
 This package contains the QML plugin providing the features from the telephony
 service to applications.

Package: qml-module-lomiri-telephony-phonenumber
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         qml-module-lomiri-components
Description: Telephony service components for Lomiri - PhoneNumber QML plugin
 Telephony PhoneNumber components for Lomiri.
 .
 This package contains the QML plugin providing the features from the telephony
 PhoneNumber to applications.

## lomiri-telephony-service 0.6.1

=== Lomiri/CMakeLists.txt ===
add_subdirectory(Telephony)

=== approver/CMakeLists.txt ===

set(qt_SRCS
    approver.cpp
    approverdbus.cpp
    )

set(approver_SRCS main.cpp ${qt_SRCS})
qt5_add_dbus_adaptor(approver_SRCS Approver.xml approver/approverdbus.h ApproverDBus)

include_directories(
    ${TP_QT5_INCLUDE_DIRS}
    ${NOTIFY_INCLUDE_DIRS}
    ${CMAKE_SOURCE_DIR}/liblomiritelephonyservice
    ${CMAKE_CURRENT_BINARY_DIR}
    )

link_directories(${MESSAGING_MENU_LIBRARY_DIRS})

add_executable(lomiri-telephony-service-approver ${approver_SRCS} ${approver_HDRS})

target_link_libraries(lomiri-telephony-service-approver
    ${TP_QT5_LIBRARIES}
    ${NOTIFY_LIBRARIES}
    lomiritelephonyservice
    Qt5::Contacts
    Qt5::Core
    Qt5::DBus
    Qt5::Gui
    Qt5::Multimedia
    Qt5::Qml
    Qt5::Feedback
    )

enable_coverage(lomiri-telephony-service-approver)

configure_file(org.freedesktop.Telepathy.Client.TelephonyServiceApprover.service.in org.freedesktop.Telepathy.Client.TelephonyServiceApprover.service)
install(TARGETS lomiri-telephony-service-approver RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.freedesktop.Telepathy.Client.TelephonyServiceApprover.service DESTINATION share/dbus-1/services)
install(FILES LomiriTelephonyServiceApprover.client DESTINATION share/telepathy/clients)
install(FILES 50-com.lomiri.TelephonyServiceApprover.pkla DESTINATION "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/lib/polkit-1/localauthority/10-vendor.d")
install(FILES 50-com.lomiri.TelephonyServiceApprover.rules DESTINATION "${CMAKE_INSTALL_FULL_DATADIR}/polkit-1/rules.d")
install(FILES com.lomiri.TelephonyServiceApprover.policy DESTINATION share/polkit-1/actions)
install(FILES com.lomiri.TelephonyServiceApprover.xml DESTINATION share/dbus-1/interfaces)

# Create accountsservice symlink for above dbus interface
install(CODE "
execute_process(COMMAND mkdir -p \"\$ENV{DESTDIR}${CMAKE_INSTALL_PREFIX}/share/accountsservice/interfaces\")
execute_process(COMMAND ln -sf ../../dbus-1/interfaces/com.lomiri.TelephonyServiceApprover.xml \"\$ENV{DESTDIR}${CMAKE_INSTALL_PREFIX}/share/accountsservice/interfaces\")
    ")

=== handler/CMakeLists.txt ===
if (PULSEAUDIO_FOUND)
    add_definitions(-DUSE_PULSEAUDIO)
    set(USE_PULSEAUDIO ON)
    set(QPULSEAUDIOENGINE_CPP qpulseaudioengine.cpp)
endif (PULSEAUDIO_FOUND)

set(qt_SRCS
    accountproperties.cpp
    callagent.cpp
    audioroutemanager.cpp
    callhandler.cpp
    chatstartingjob.cpp
    farstreamchannel.cpp
    handler.cpp
    handlerdbus.cpp
    messagejob.cpp
    messagesendingjob.cpp
    powerdaudiomodemediator.cpp
    powerddbus.cpp
    texthandler.cpp
    ${QPULSEAUDIOENGINE_CPP}
    )

set(handler_SRCS main.cpp ${qt_SRCS})
qt5_add_dbus_adaptor(handler_SRCS Handler.xml handler/handlerdbus.h HandlerDBus)
qt5_add_dbus_adaptor(handler_SRCS ChatStartingJob.xml handler/chatstartingjob.h ChatStartingJob)
qt5_add_dbus_adaptor(handler_SRCS MessageSendingJob.xml handler/messagesendingjob.h MessageSendingJob)

include_directories(
    ${TP_QT5_INCLUDE_DIRS}
    ${TPFS_INCLUDE_DIRS}
    ${FS_INCLUDE_DIRS}
    ${GST_INCLUDE_DIRS}
    ${CMAKE_SOURCE_DIR}/liblomiritelephonyservice
    ${CMAKE_CURRENT_BINARY_DIR}
    ${PULSEAUDIO_INCLUDE_DIRS}
    ${HISTORY_INCLUDE_DIRS}
    )

add_executable(lomiri-telephony-service-handler ${handler_SRCS} ${handler_HDRS})

target_link_libraries(lomiri-telephony-service-handler
    ${TP_QT5_LIBRARIES}
    ${TP_QT5_FS_LIBRARIES}
    ${TPFS_LIBRARIES}
    ${FS_LIBRARIES}
    ${HISTORY_LIBRARIES}
    lomiritelephonyservice
    ${PULSEAUDIO_LIBRARIES}
    Qt5::Contacts
    Qt5::Core
    Qt5::DBus
    Qt5::Qml
    )

enable_coverage(lomiri-telephony-service-handler)

configure_file(com.lomiri.TelephonyServiceHandler.service.in com.lomiri.TelephonyServiceHandler.service)
configure_file(org.freedesktop.Telepathy.Client.TelephonyServiceHandler.service.in org.freedesktop.Telepathy.Client.TelephonyServiceHandler.service)

install(TARGETS lomiri-telephony-service-handler RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.freedesktop.Telepathy.Client.TelephonyServiceHandler.service DESTINATION share/dbus-1/services)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/com.lomiri.TelephonyServiceHandler.service DESTINATION share/dbus-1/services)
install(FILES LomiriTelephonyServiceHandler.client DESTINATION share/telepathy/clients)

=== indicator/CMakeLists.txt ===
include(FindGettext)

set(qt_SRCS
    authhandler.cpp
    callchannelobserver.cpp
    displaynamesettings.cpp
    messagingmenu.cpp
    metrics.cpp
    textchannelobserver.cpp
    ussdindicator.cpp
    notificationmenu.cpp
    voicemailindicator.cpp
    indicatordbus.cpp
    )

set_source_files_properties(
        "${DATA_DIR}/org.freedesktop.Notifications.xml"
        PROPERTIES
        INCLUDE "${CMAKE_SOURCE_DIR}/indicator/DBusTypes.h"
)

set(notifications-interface_SRCS "")
qt5_add_dbus_interface(
        notifications-interface_SRCS
        "${DATA_DIR}/org.freedesktop.Notifications.xml"
        NotificationsInterface
)
add_library(notifications-interface STATIC ${notifications-interface_SRCS})
target_link_libraries(notifications-interface PUBLIC Qt5::DBus)

qt5_add_dbus_adaptor(qt_SRCS Indicator.xml indicator/indicatordbus.h IndicatorDBus)

set(indicator_SRCS main.cpp ${qt_SRCS})


include_directories(
    ${TP_QT5_INCLUDE_DIRS}
    ${NOTIFY_INCLUDE_DIRS}
    ${MESSAGING_MENU_INCLUDE_DIRS}
    ${CMAKE_SOURCE_DIR}/liblomiritelephonyservice
    ${CMAKE_CURRENT_BINARY_DIR}
    ${UserMetrics_INCLUDE_DIRS}
    ${HISTORY_INCLUDE_DIRS}
    )

link_directories(${MESSAGING_MENU_LIBRARY_DIRS})

add_executable(lomiri-indicator-telephony-service ${indicator_SRCS} ${indicator_HDRS})

target_link_libraries(lomiri-indicator-telephony-service
    ${TP_QT5_LIBRARIES}
    ${NOTIFY_LIBRARIES}
    ${MESSAGING_MENU_LIBRARIES}
    ${UserMetrics_LIBRARIES}
    ${HISTORY_LIBRARIES}
    lomiritelephonyservice
    notifications-interface
    Qt5::Contacts
    Qt5::Core
    Qt5::DBus
    Qt5::Gui
    Qt5::Multimedia
    Qt5::Qml
    )

enable_coverage(lomiri-indicator-telephony-service)

configure_file(org.freedesktop.Telepathy.Client.TelephonyServiceIndicator.service.in org.freedesktop.Telepathy.Client.TelephonyServiceIndicator.service)
install(TARGETS lomiri-indicator-telephony-service RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.freedesktop.Telepathy.Client.TelephonyServiceIndicator.service DESTINATION share/dbus-1/services)
install(FILES LomiriTelephonyServiceIndicator.client DESTINATION share/telepathy/clients)

# Handle i18n in desktop files
set(desktop_FILES lomiri-telephony-service-sms.desktop lomiri-telephony-service-call.desktop)

function(merge_desktop_translations DESKTOP_FILES)
    foreach(DESKTOP_FILE ${DESKTOP_FILES})
        add_custom_target(${DESKTOP_FILE} ALL
            COMMENT "Merging translations into ${DESKTOP_FILE}..."
            COMMAND ${GETTEXT_MSGFMT_EXECUTABLE}
                    -d ${CMAKE_SOURCE_DIR}/po
                    --desktop
                    --template=${CMAKE_CURRENT_SOURCE_DIR}/${DESKTOP_FILE}.in
                    -o ${DESKTOP_FILE}
        )

        install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_FILE}
                DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
    endforeach()
endfunction()

merge_desktop_translations("${desktop_FILES}")

add_subdirectory(icons)

=== liblomiritelephonyservice/CMakeLists.txt ===
set(library_SRCS
    accountentry.cpp
    accountentryfactory.cpp
    accountlist.cpp
    audiooutput.cpp
    applicationutils.cpp
    callentry.cpp
    callmanager.cpp
    callnotification.cpp
    channelobserver.cpp
    chatmanager.cpp
    chatentry.cpp
    contactutils.cpp
    contactwatcher.cpp
    greetercontacts.cpp
    ofonoaccountentry.cpp
    participant.cpp
    phoneutils.cpp
    protocol.cpp
    protocolmanager.cpp
    ringtone.cpp
    rolesinterface.cpp
    telepathyhelper.cpp
    tonegenerator.cpp
    ussdmanager.cpp
    )

include_directories(
    ${TP_QT5_INCLUDE_DIRS}
    ${NOTIFY_INCLUDE_DIRS}
    ${LibPhoneNumber_INCLUDE_DIRS}
    ${URL_DISPATCHER_INCLUDE_DIRS})

add_library(lomiritelephonyservice STATIC ${library_SRCS} ${library_HDRS})
set_target_properties(lomiritelephonyservice PROPERTIES COMPILE_DEFINITIONS AS_BUSNAME=systemBus)
target_link_libraries(lomiritelephonyservice
                      ${TP_QT5_LIBRARIES}
                      ${NOTIFY_LIBRARIES}
                      ${LibPhoneNumber_LIBRARIES}
                      ${URL_DISPATCHER_LIBRARIES}
                      Qt5::Contacts
                      Qt5::Core
                      Qt5::DBus
                      Qt5::Feedback
                      Qt5::Multimedia
                      Qt5::Qml
                      Qt5::Quick
                      Qt5::Gui
                      )

enable_coverage(lomiritelephonyservice)

=== po/CMakeLists.txt ===
include(FindGettext)

find_program(GETTEXT_XGETTEXT_EXECUTABLE xgettext)
if("${GETTEXT_XGETTEXT_EXECUTABLE}" STREQUAL "GETTEXT_XGETTEXT_EXECUTABLE-NOTFOUND")
    message(FATAL_ERROR "Could not find xgettext")
endif()

set(DOMAIN ${PROJECT_NAME})
set(POT_FILE ${DOMAIN}.pot)
set(DESKTOP_IN_FILES
    indicator/lomiri-telephony-service-call.desktop.in
    indicator/lomiri-telephony-service-sms.desktop.in)

file(STRINGS ${CMAKE_CURRENT_SOURCE_DIR}/LINGUAS LINGUAS
     REGEX "^[^#].*")
string(REGEX MATCHALL "[^ \t]+" LANGS "${LINGUAS}")

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/POTFILES.in
               ${CMAKE_CURRENT_BINARY_DIR}/POTFILES COPYONLY)

add_custom_target(${POT_FILE} ALL
                  COMMENT "Generating translation template"
                  COMMENT "Generating translation template"
                  # Extract the translatable messages from the desktop file
                  COMMAND ${GETTEXT_XGETTEXT_EXECUTABLE} -o ${POT_FILE}
                          --from-code=UTF-8
                          --language=Desktop
                          --package-name='${PROJECT_NAME}'
                          --copyright-holder='Canonical Ltd.'
                          -D ${CMAKE_SOURCE_DIR}
                          ${DESKTOP_IN_FILES}
                  COMMAND ${GETTEXT_XGETTEXT_EXECUTABLE} -o ${POT_FILE}
                          -D ${CMAKE_SOURCE_DIR}
                          -D ${CMAKE_CURRENT_SOURCE_DIR}
                          -D ${CMAKE_CURRENT_BINARY_DIR}
                          --from-code=UTF-8
                          --c++
                          --qt
                          --add-comments=TRANSLATORS
                          --keyword=tr
                          --keyword=tr:1,2
                          --keyword=GettextMarkExtraction
                          --package-name='${PROJECT_NAME}'
                          --copyright-holder='Canonical Ltd.'
                          --join-existing
                          --files-from=${CMAKE_CURRENT_BINARY_DIR}/POTFILES)

foreach(LANG ${LANGS})
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${LANG}.po
                   ${CMAKE_CURRENT_BINARY_DIR}/${LANG}.po
                   COPYONLY)
endforeach(LANG)
gettext_process_pot_file(${POT_FILE} ALL
                         INSTALL_DESTINATION ${CMAKE_INSTALL_LOCALEDIR}
                         LANGUAGES ${LANGS})

=== tools/CMakeLists.txt ===
configure_file(
  ofono-setup.in
  ofono-setup
  @ONLY
)

install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/ofono-setup DESTINATION ${CMAKE_INSTALL_BINDIR})
install(PROGRAMS phone-gsettings-migration.py DESTINATION ${CMAKE_INSTALL_BINDIR})

=== Lomiri/Telephony/CMakeLists.txt ===
# QML plugin

set(plugin_SRCS
    presencerequest.cpp
    participantsmodel.cpp
    components.cpp
    )

include_directories(
    ${TP_QT5_INCLUDE_DIRS}
    ${CMAKE_SOURCE_DIR}/liblomiritelephonyservice
    )

add_library(lomiritelephonyservice-qml SHARED ${plugin_SRCS} ${plugin_HDRS})

target_link_libraries(lomiritelephonyservice-qml
    ${TP_QT5_LIBRARIES}
    lomiritelephonyservice
    Qt5::Contacts
    Qt5::Core
    Qt5::Qml
    Qt5::Quick
    )

enable_coverage(lomiritelephonyservice-qml)

configure_file(qmldir.in ${CMAKE_CURRENT_BINARY_DIR}/qmldir)
set(PLUGIN_DIR ${QT_INSTALL_QML}/Lomiri/Telephony)
install(TARGETS lomiritelephonyservice-qml DESTINATION ${PLUGIN_DIR})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/qmldir DESTINATION ${PLUGIN_DIR})

add_subdirectory(PhoneNumber)

=== indicator/icons/CMakeLists.txt ===
set (icon-theme Humanity)

set(icons
    notification-group-call.svg
    notification-unavailable-image-call.svg
    notification-unknown-call.svg
    )

install(FILES ${icons} DESTINATION share/notify-osd/icons/${icon-theme}/scalable/status)

=== tests/Lomiri.Telephony/CMakeLists.txt ===
include_directories(
    ${CMAKE_CURRENT_BINARY_DIR}
    ${TP_QT5_INCLUDE_DIRS}
    ${CMAKE_SOURCE_DIR}/Lomiri/Telephony
    ${CMAKE_SOURCE_DIR}/liblomiritelephonyservice
    ${CMAKE_SOURCE_DIR}/tests/common
    ${CMAKE_BINARY_DIR}/tests/common
    ${GSETTINGS_QT_INCLUDE_DIRS}
    )

set(SOURCE_DIR ${CMAKE_SOURCE_DIR}/Lomiri/Telephony)
generate_test(ContactWatcherTest USE_UI
              SOURCES ContactWatcherTest.cpp
              LIBRARIES lomiritelephonyservice-qml Qt5::Contacts Qt5::Core Qt5::DBus Qt5::Qml Qt5::Test)

if(NOT SKIP_QML_TESTS)
    generate_test(context_properties QML_TEST tst_contextProperties.qml)
    generate_test(phonenumber_field QML_TEST tst_PhoneNumberField.qml)
    generate_test(phonenumber_input QML_TEST tst_PhoneNumberInput.qml)
    generate_test(phonenumber_utils QML_TEST tst_PhoneNumberPhoneUtils.qml)
endif()

generate_telepathy_test(PresenceRequestTest 
                        SOURCES PresenceRequestTest.cpp 
                        LIBRARIES ${TP_QT5_LIBRARIES} lomiritelephonyservice mockcontroller telepathytest lomiritelephonyservice-qml)

# make the files visible on qtcreator
file(GLOB QML_TESTS *.qml *.js)
add_custom_target(lomiritelephonyservice_QMLTESTS ALL SOURCES ${QML_TESTS})

=== tests/approver/CMakeLists.txt ===
include_directories(
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/../common
    ${CMAKE_SOURCE_DIR}
    ${CMAKE_SOURCE_DIR}/liblomiritelephonyservice
    ${CMAKE_BINARY_DIR}/tests/common
    ${TP_QT5_INCLUDE_DIRS}
    ${GSETTINGS_QT_INCLUDE_DIRS}
    )

if (NOT ("${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "aarch64"))
    generate_telepathy_test(ApproverTest
                            SOURCES ApproverTest.cpp approvercontroller.cpp
                            TASKS --task ${CMAKE_BINARY_DIR}/approver/lomiri-telephony-service-approver --task-name lomiri-telephony-service-approver --wait-for com.lomiri.TelephonyServiceHandler --ignore-return
                            WAIT_FOR org.freedesktop.Telepathy.Client.TelephonyServiceApprover)
endif()

=== tests/handler/CMakeLists.txt ===
include_directories(
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/../common
    ${CMAKE_SOURCE_DIR}
    ${CMAKE_SOURCE_DIR}/liblomiritelephonyservice
    ${CMAKE_BINARY_DIR}/tests/common
    ${TP_QT5_INCLUDE_DIRS}
    ${GSETTINGS_QT_INCLUDE_DIRS}
    )

generate_telepathy_test(HandlerTest SOURCES HandlerTest.cpp handlercontroller.cpp approver.cpp)

=== debian/changelog ===
lomiri-telephony-service (0.6.1-1build1) resolute; urgency=medium

  * No-change mass rebuild for Ubuntu 26.04 (LP: #2132257)

 -- Sebastien Bacher <seb128@debian.org>  Wed, 11 Feb 2026 23:31:16 +0100

lomiri-telephony-service (0.6.1-1) unstable; urgency=medium

  * New upstream release.
  * debian/control:
    + Bump Standards-Version: to 4.7.2. No changes needed.
  * debian/copyright:
    + Fix FSF mailing address.
    + Update copyright attributions for debian/.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 05 May 2025 11:11:34 +0200
